package client;
import java.applet.*;
import java.awt.*;
import java.lang.*;
import java.io.*;
import java.net.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
//<applet code="ChatClient.class" width=200 height=300></applet>
public class ChatClient extends JApplet{
	private  int 	default_port = 1223, port;
	private Socket	socket_to_server;
	private DataInputStream	stream_from_server;
	public DataOutputStream	stream_to_server;
	private JButton	jb_logout, jb_login;				
	private JTextField jtf_chat_string;
	private JTextArea jta_chatDisplay;
	private ChatHandler	listener;
	private JScrollPane 	scrollPane;
	private String login_name;
	private boolean	isFirst = true;
	private String	name;
	private boolean	restart = false;
	private JDialog jd_chat_name;
	private JButton jb_ok= new JButton("OK"), jb_cancel = new JButton("Cancel");
	private JTextField tf_chat_name = new JTextField(10);
       
	private void initUI() {
    		Font font = new Font( "Dialog", Font.BOLD, 15);
		getContentPane().setLayout(new BorderLayout());		
		jtf_chat_string = new JTextField();
		jb_logout = new JButton("Log Out");
		jb_login = new JButton("Log In");
		jb_login.setToolTipText("logging in with new chat name");
	    	jb_logout.setFont(font);
		jb_logout.setToolTipText("logging out chatRoom");
		
		jd_chat_name= new JDialog();
		jd_chat_name.setTitle("ȭ Է ̾α");
		JPanel dummy = new JPanel ();
		dummy.add(jb_ok);
		dummy.add(jb_cancel);
		JPanel p = new JPanel ();
	
		p.add(new Label("Chat Name: "));
		p.add(tf_chat_name);
		jd_chat_name.getContentPane().add(p, BorderLayout.NORTH);
		jd_chat_name.getContentPane().add(dummy, BorderLayout.SOUTH);
		jd_chat_name.pack();
		
		jta_chatDisplay = new JTextArea("\n");
		jta_chatDisplay.setBackground(Color.black);
		jta_chatDisplay.setForeground(Color.green);
		jta_chatDisplay.append("Login Button ȭ Էϸ ä  ˴ϴ.\n");
		jta_chatDisplay.append(" '/exit' Է ϰų logout ư Ŭϼ .\n");
		jta_chatDisplay.append("ٽýϷ '/open' Էϰų login ư Ŭϼ\n");
		jta_chatDisplay.setEditable(false);
		jb_logout.setEnabled(false);
		
		JPanel tmpPanel = new JPanel();
		tmpPanel.add(jb_login);
		tmpPanel.add(jb_logout);
        	scrollPane = new JScrollPane(jta_chatDisplay);
        	
		getContentPane().add(tmpPanel , BorderLayout.NORTH);
		getContentPane().add(scrollPane, BorderLayout.CENTER);
		getContentPane().add(jtf_chat_string, BorderLayout.SOUTH);
	}
	
	private void addListeners() {
		ActionListener log_in_out_listener =  new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Object source = e.getSource();
				if(source == jb_logout) {	
					try {
						closeConnection();
					}
					catch (IOException ex) {
						ChatClient.this.showStatus(ex.getMessage());
					}
				} else if(source == jb_login) {
					jd_chat_name.setLocation(ChatClient.this.getLocationOnScreen().x + 50,
					 ChatClient.this.getLocationOnScreen().y + 50);
					jd_chat_name.setVisible(true);
									
				} else if(source == jb_ok) {
					login_name = tf_chat_name.getText();
					try {
						openConnection();
					} catch(IOException ex) {
						ChatClient.this.showStatus(ex.getMessage());
						return;
					}
			
					jta_chatDisplay.setText("Chat Name  " + login_name + "   Ǿϴ.\n");
					jd_chat_name.setVisible(false);
				} else if(source == jb_cancel) {
					jd_chat_name.setVisible(false);
				}
				
			}
		};
		ActionListener tf_listener = new ActionListener() {
			public void actionPerformed(ActionEvent e) {
					
				String input = e.getActionCommand().trim();
				jtf_chat_string.setText("");
				
				if(input.equals("/open") && restart) {
					try {
						openConnection();
					} catch(IOException ex) {
						ChatClient.this.showStatus(ex.getMessage());
						return;
					}
					jta_chatDisplay.setText("ٽ  Ǿϴ.\n");
							
				}
	
				if (input.equals("/exit")) {
					try {
						closeConnection();
					} catch (IOException ex) {
						jta_chatDisplay.append("Server could be down\n");
					}
				}
				if(!isFirst && !(input.equals("/open")) ) {
					try{
						stream_to_server.writeUTF("[" + login_name + "] " + e.getActionCommand());
						jtf_chat_string.setText("");
					} catch(IOException ex){
					}
				}
			}
		};
		
		jb_logout.addActionListener(log_in_out_listener);
		jb_login.addActionListener(log_in_out_listener);
		jb_ok.addActionListener(log_in_out_listener);
		jb_cancel.addActionListener(log_in_out_listener);
		jtf_chat_string.addActionListener(tf_listener);
	}
	public void openConnection() throws IOException {
		String str_port = getParameter("port");
		if( str_port != null) {
			port = Integer.parseInt(str_port);
		} else {
			port = default_port;
		}
		socket_to_server = new Socket(this.getCodeBase().getHost(), port);
		stream_from_server = new DataInputStream(socket_to_server.getInputStream());
		stream_to_server = new DataOutputStream(socket_to_server.getOutputStream());
		listener = new ChatHandler(stream_from_server, jta_chatDisplay, scrollPane);
		this.showStatus("Connected to " + socket_to_server.getInetAddress().getHostName());
		stream_to_server.writeUTF(login_name + "  ϼ̽ϴ.\n");
		isFirst = false;
		restart = false;
		jb_login.setEnabled(false);
		jb_logout.setEnabled(true);
		jtf_chat_string.requestFocus();
		jtf_chat_string.setText("");
	}
	public void closeConnection() throws IOException {
		stream_to_server.writeUTF(" " + login_name + " Բ ̽ϴ.");  	
		restart = true;
		socket_to_server.close();
		stream_to_server.close();
		jb_logout.setEnabled(false);
		jb_login.setEnabled(true);
	}
	
	public void init() {
		initUI();
		addListeners();
	}
	public void start() {
	}
	public void stop () {
		
	}
	
	public void paint(Graphics g) {
		super.paint(g);
	}
}	


class ChatHandler extends Thread {
	DataInputStream	stream_from_server;
	JTextArea output;
	JScrollPane scrollPane  = null;
	JScrollBar vScroll = null;
	public ChatHandler(DataInputStream stream_from_server, JTextArea output, JScrollPane scrollPane) {
		this.stream_from_server = stream_from_server;
		this.output = output;
		this.scrollPane = scrollPane;
		this.start();
	}
	public void run() {
		String line;
		try {
			while(true) {
				line = stream_from_server.readUTF();
				if (line == null) break;
				output.append(line+'\n');
				vScroll = scrollPane.getVerticalScrollBar();
				vScroll.setValue(vScroll.getMaximum());
			}
		} 
		catch (IOException e){
			output.setText(e.toString());
		}
		finally {
			output.setText("Connection closed by server.\n");
			output.append("ٽ Ͻ÷ '/open' ̶ .\n");
		}
	}
}
