package pjsp.shopmall.database;
import java.sql.*;
import java.io.*;
import java.util.Vector;
import java.util.Properties;
import java.util.Enumeration;

public class ConnPool {
// ̽ ¾   ܺο   ֵ Ƽ  Ѵ.
	private Properties dbProperties;
//ִ(Ǿ ʴ) Connection Vector· .
	private Vector waitingPool;
//ҴǾ(ǰ ִ) Connection Vector· .
	private Vector usingPool;

// ̹ ̸	
	private String driverName;
// ͺ̽ url 
	private String dbURL;
// ͺ̽ user	
	private String dbUser;
// ͺ̽ user password	
	private String dbPasswd;

//ʱ⿡  Connetion .
	private int init_connections;
//    ִ Connetion ִġ .	
	private int max_connections;
// Connection .	
	private int connections_created;
//ݳǾ Connection ٸ ð.	
	private long wait_time;
//Ƽ Ϸ  ͺ̽ ῡ     .
	private boolean initFromProperties = true; 

//ConnPool Ŭ 
public ConnPool(){	}

//initFromProperties ϴ setter޼ҵ
public void setInitFromProperties(boolean init) {
	initFromProperties = init;
}

public void setUp() throws SQLException, ClassNotFoundException , IOException {
	if(initFromProperties) {
		init();
	}

	Class.forName(this.driverName);
//ڹ   ̳ ȭ鿡 ̹ ε尡  ̷ ش.
	System.out.println("Driver " + this.driverName + " Loaded successfully");
//max_connections 0̰ų 0   max_connections  Ѵ.	
	if(max_connections <= 0) {
	max_connections = 5;
	}
//max_connections init_connections   max_connections init_connections ߾ ش.	
	if (max_connections < init_connections) {
		init_connections = max_connections;
	}
/* Connection    ֵ init_connectionsŭ
  ʱ ۸ Ȯϸ鼭 Vecotr . */
	waitingPool = new Vector(init_connections);
	usingPool = new Vector(init_connections);
/*  Connection  init_connections ٴٸ  
  ο Connection . */
	for(int i = 0; i < init_connections; i++) {
		addConnection();
	}
}

/*Conncection   ޼ҵ.
    Ѿ      
  ̵  getConnection(boolean block, long timeout) ȣѴ.*/
public Connection getConnection()throws SQLException {
/*ڹ   ̳ ȭ鿡   ִ Connection  Ǯ 
  ִ  Connection  ش. */
	System.out.println("connections available: " + waitingPool.size());
	System.out.println("total connections made: " + (waitingPool.size() + usingPool.size()));
//̵  getConnection ٽ ȣϿ   ȯѴ.
	return getConnection(wait_time);
}

/*Connection ϴ ü   Connectionü
  ConnPoolü ݳ. */
public synchronized void releaseConnection(Connection connection) {
/*waitingPool Connection Ű Connection 䱸ϰ  ٸ ִ ٸ
  ü鿡 Connection ȯǾ  ˸.
  , wait() ȣϿ ޼ҵ忡 notify() ִ ̴. */
	notify();

/*usingPool ȯ Connectionü ϰ,
  waitingPool ű. */
	usingPool.removeElement(connection);
	connections_created--;

	waitingPool.addElement(connection);
	connections_created++;
//ڹ   ̳ ȭ鿡 	Connection ȯǾ ˸.
	System.out.println("Connection released");
}

//Connectionü ޸𸮿  ϰ Connection closeŲ.
public synchronized void closeAll() {

/*Enumerationü Ͽ waitingPool ִ element ´. */
	Enumeration cons = ((Vector)waitingPool.clone()).elements();

/*Enumerationü element    
  free Ҵ Connection ϰ  Connection Ѵ. */
	while (cons.hasMoreElements()) {
		Connection connection = (Connection)cons.nextElement();
		waitingPool.removeElement(connection);
		connections_created--;
		try {
// Connection ݾش.
			connection.close();
		} catch (SQLException e) {		}
	}
//usingPool Ҵ Connection Ѵ.
	cons = ((Vector)usingPool.clone()).elements();
	while (cons.hasMoreElements()) {
		Connection connection = (Connection)cons.nextElement();
		usingPool.removeElement(connection);
	}
	System.out.println("Closed All connections in waiting pool and disable all active connections");
}

//ConnPoolü Ƽ ȯϴ getter ޼ҵ
public int getMaxConnections() {
	return max_connections;
}
public long getWaitTime() {
	return wait_time;
}
public String getDbURL() {
	return dbURL;
}
public String getDbPasswd() {
	return this.dbPasswd;
}
public String getDbUser() {
	return this.dbUser;
}
public int getInitConnections() {
	return this.init_connections;
}
//////////////////////////////////////////////////////////////////////

//ConnPoolü Ƽ ϴ setter ޼ҵ
public void setInitConnections(int init_connections) {
	this.init_connections = init_connections;
}
public void setDbUser(String dbUser) {
	this.dbUser = dbUser;
}
public void setDbPasswd(String dbPasswd) {
	this.dbPasswd = dbPasswd;
}
public void setDbURL(String dbURL) {
	this.dbURL = dbURL;
}
public void setWaitTime(long wait_time) {
	this.wait_time = wait_time;
}
public void setMaxConnections(int max_connections) {
	this.max_connections = max_connections;
}
//////////////////////////////////////////////////////////////////////

/*Connectionü ȯϴ ޼ҵ. 
  Connection   ȭ  ذϱ  synchronized óϰ ִ.*/
private synchronized Connection getConnection(long wait_time)throws SQLException {

//  ִ Connection  .
	if (waitingPool.isEmpty()) {
// Connection  max_connections   ο Connection  Ѵ.
		if (connections_created < max_connections) {
			addConnection();
		} else { 
/* ̹ Connection  Ǿ   Ѵ.
    ðκ  Ƽ timeout  ðŭ (wait())Ѵ. */
			long start = System.currentTimeMillis();
			long elapsedTime = 0;
			try {
				while(waitingPool.isEmpty() && connections_created >= max_connections){
					this.wait(wait_time);
					elapsedTime = System.currentTimeMillis() - start;
					wait_time -= elapsedTime;
					if(wait_time <= 0) break;
				}
			} catch (InterruptedException e) {		}

/*wait_timeŭ ٸٰ    ִ Connection , 
   Connection  max_connections   Connection ϰ,
  ׷  쿡 ð ʰǾ ˸ Exception ߻Ų. */
			if (waitingPool.isEmpty()) {
				if (connections_created < max_connections) {
					addConnection();
				} else {
					throw new SQLException("wait_time for a connection to be released expired");
				}
			}
		}//end of else
	}//end of outer-most if clause 

	Connection connection;
/*waitingPool ִ Connection usingPool ű ,
  Connection û ü  reference ȯش.
  synchronizedȿ ٽ synchronized    
  used ü  lock flag   ν interruptȲ 
  ߻  ϰ ȭ Ű ̴. */
	synchronized (usingPool) {
		connection = (Connection)waitingPool.lastElement();
		waitingPool.removeElement(connection);
		usingPool.addElement(connection);
	}
	return connection;
}

//Connection add.
private void addConnection() throws SQLException {
	waitingPool.addElement(createConnection());
}

//ο Connection .
private Connection createConnection() throws SQLException {
	Connection connection = null;
	try {
//̹ Ŵ  Connection ´.
		connection = DriverManager.getConnection(dbURL,dbUser,dbPasswd);

/*⺻ Connection Ǹ ڵ commit尡 Ǵµ ̸ ϴ 쿡
   Connectionü setAutoCommit(false)  ȣѴ. 
   ڵ commit   쿡   ص . */
		connection.setAutoCommit(false);
		System.out.println("Successfully created a new connection from " + dbURL);
	} catch (SQLException e) {
		e.printStackTrace();
	}
// Connection  Ų  ȯѴ.
	connections_created++;
	return connection;
}

/*  ʱȭ Ѵ. 
  Ƽ  ϸ  ̽  κ ٲ ڹ
  ڵ带 ϰ,  ϴ  ̵ ܺο Ƽ 
  ٲν   ذǾ   ִ.   */
private void init() throws IOException {
//java.util Ű Ƽ ü Ѵ.
	dbProperties = new Properties();
	try {
/*  Ƽ Ϸ   ̽    ´.
     Ƽ  ġ   н  Ȳ ° ٲپش. */
		File filePath = new File("D:\\jspbook\\chapter5\\code\\connectionpool\\db.properties");
//Ƽ  о ؼ FileInputStream Ѵ.
		FileInputStream fin = new FileInputStream(filePath);
// FileInputStream ؼ Ƽ εѴ
		dbProperties.load(fin);
	} catch(IOException e) {
		throw e;
	}
//Ƽ Ϸ   Ƽ     Ѵ.
	this.dbURL = dbProperties.getProperty("dbURL");
	this.driverName = dbProperties.getProperty("driverName");
	this.dbUser = dbProperties.getProperty("dbUser");
	this.dbPasswd = dbProperties.getProperty("dbPasswd");
	this.init_connections = Integer.parseInt(dbProperties.getProperty("init_connections"));
	this.max_connections = Integer.parseInt(dbProperties.getProperty("max_connections"));
	this.wait_time = Long.parseLong(dbProperties.getProperty("wait_time"));
}

}


