import java.util.*;
import java.io.*;
import javax.ejb.*;
import javax.naming.*;
import javax.rmi.PortableRemoteObject;
public class BookBean {
	private String isbn;
	private String title;
	private String author;
	private long price;
	
	private BookHome home = null;
	private String message = "";
	private String str_book; 
	private StringBuffer buffer = new StringBuffer();
	private final int CREATE = 1;
	private final int FIND_BY_PRIMARY = 2;
	private final int FIND_BY_TITLE = 3;
	
	public BookBean () {
		try {
			this.home = getHome();
		} catch(Exception e) {
			message = "Ȩ ̽  ۷  ߽ϴ.";
			e.printStackTrace();
		}	
	}
	////////////Write Only Property Methods /////////////
	public void setIsbn(String isbn) {
		this.isbn = isbn;
	}
	public void setTitle(String title) {
		this.title = title;
	}
	public void setAuthor(String author) {
		this.author = author;
	}
	public void setPrice(String str_price){
		try {
			this.price = Long.parseLong(str_price);
		} catch(NumberFormatException e) {
			this.price = 0;
		}
	}
	public void setRequest(String request) {
		int type = 0;
		type = Integer.parseInt(request);
		Book book;
		switch(type) {
			case CREATE:
			{
				try {
					book = home.create(asc2ksc(isbn), asc2ksc(title), asc2ksc(author), price);
					message ="  Ǿϴ.";
				} catch(Exception e) {
					e.printStackTrace();
					message = "BookEJB νϽ   ۷  ߽ϴ.";
					message += "<BR>price  ߴ Ȯ Ͻʽÿ";
				}
				break;
			}
			case FIND_BY_PRIMARY:
			{
				try {
					book = home.findByPrimaryKey(asc2ksc(isbn));
					message = " ˻Ǿϴ.";
					setBook(book);
				} catch(Exception e) {
					e.printStackTrace();
					message = "˻Ͻ å ã ߽ϴ.";
					message += "<BR>isbn  Ȯ Ȯ Ͻʽÿ.";
				}
				break;
				
			}
			case FIND_BY_TITLE:
			{
				try {
					Collection books = home.findByTitle(asc2ksc(title));
					message = " ˻Ǿϴ.";		
					setBook(books);
				} catch(Exception e) {
					e.printStackTrace();
					message = " " + title + "   ϴ.";
				}
				break;
			}
			default:
				message = "Unknown Request";
				break;
		}
	}
	
	/////////////Read Only Proeperty Methods /////////////////
	public BookBean getBook() {
		return this;
	}
	public String getMessage() {
		return message;
	}
	
	///////////////// Utility Methods /////////////////////
	private BookHome getHome() throws Exception {
		InitialContext ic = new InitialContext();
		Object obj = ic.lookup("java:comp/env/ejb/BookCMP");
		BookHome home = (BookHome)PortableRemoteObject.narrow(obj, BookHome.class);
		return home;
	}
	private void setBook(Book book) throws java.rmi.RemoteException {
		buffer.append("<table border=\"1\" cellpadding=\"5\"");
		buffer.append("<tr bgcolor=\"#FFE4FF\">");
		buffer.append("<th>å</th><th></th><th>ISBN</th><th></th></tr>");
		buffer.append("<tr bgcolor=\"#FFF0F0\"><td>");
		buffer.append(book.getTitle() + "</td><td>");
		buffer.append(book.getAuthor() + "</td><td>");
		buffer.append(book.getIsbn() + "</td><td>");
		buffer.append(book.getPrice() + " </td></tr>");
		buffer.append("</table>");
		
		
	}
	private void setBook(Collection books) throws java.rmi.RemoteException{
		Iterator it = books.iterator();
		buffer.append("<table border=\"1\" cellpadding=\"5\"");
		buffer.append("<tr bgcolor=\"#FFE4FF\">");
		buffer.append("<th>å</th><th></th><th>ISBN</th><th></th></tr>");
		while(it.hasNext()) {
			Book book = (Book) it.next();
			buffer.append("<tr bgcolor=\"#FFF0F0\"><td>");
			buffer.append(book.getTitle() + "</td><td>");
			buffer.append(book.getAuthor() + "</td><td>");
			buffer.append(book.getIsbn() + "</td><td>");
			buffer.append(book.getPrice() + "</td></tr>");
		}
		buffer.append("</table>");
	}
	public String asc2ksc(String asc) {
		if(asc == null) return null;
		try {
			return new String(asc.getBytes("8859_1"), "ksc5601");
		} catch(UnsupportedEncodingException e) {
			e.printStackTrace();
			return asc;
		}
	}
	public String toString() {
		String str = buffer.toString();
		buffer.delete(0, buffer.length());
		return str;
	}

}