import java.util.*;	
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
public class BookEJBClient {
	public static void main(String[] args) {
		try {
			Context initial = new InitialContext();
			Object objref = initial.lookup("Book");
			BookHome home = 
			(BookHome)PortableRemoteObject.narrow(objref, BookHome.class);
			
			Book book1 = 
			home.create("abcnf-123", "Java Programming Language", "Yang Hooe Suk", 23000);
			Book book2 = 
			home.create("aaaa-1234", "Java Programming Language", "ƹ", 25000);
			Book pjsp = 
			home.create("abcdef-456", "Perfect Java Server Pages", "Yang Hooe Suk", 33000);
			
			Book jpl_1 = home.findByPrimaryKey("abcnf-123");
			Collection books  = home.findByTitle("Java Programming Language");
			Iterator it = books.iterator();
			while(it.hasNext()) {
				Object obj = it.next();
				Book b = (Book)PortableRemoteObject.narrow(obj, Book.class);
				System.out.println("isbn: " + b.getIsbn() + " title: "
				 + b.getTitle() + " author: " + b.getAuthor() + " price: " + b.getPrice());	
			}
			/*
			book1.remove();
			book2.remove();
			pjsp.remove();
			*/
		} catch (Exception ex) {
			System.err.println("Caught an exception." );
			ex.printStackTrace();
		}
	}	 
} 
